//+------------------------------------------------------------------+
//|                              SoftFractalsStrategyModel_1_4_8.mq4 |
//|                                                    .. |
//+------------------------------------------------------------------+
// 1.0    11/03/2011    SoftFractals     |
//           .                              |
//+------------------------------------------------------------------+
// 1.1    12/03/2011          |
//           (SoftFractalsByClose).              |
//+------------------------------------------------------------------+
// 1.2    14/03/2011       |
//        (  1-2-3),   .        |
//+------------------------------------------------------------------+
// 1.3    16/03/2011  "" ,  3     |
//            1-2(  Gerasimm).    |
//+------------------------------------------------------------------+
// 1.3.1  17/03/2011    "" |
//         1-2-3(  "" ).              |
//+------------------------------------------------------------------+
// 1.2.1  18/03/2011         |
// 1.3.2  (  dzhini).                                  |
//+------------------------------------------------------------------+
// 1.3.3  18/03/2011             |
//        ""  ,  SL  TP.  -   |
//          "" ( 1.2).  |
//+------------------------------------------------------------------+
// 1.4    23/03/2011        |
//        Buy  Sell.           |
//         . "" .                        |
//+------------------------------------------------------------------+
// 1.4.1  24/03/2011    ""(    |
//        ,-  Gerasimm),  "" . |
//             .       |
//+------------------------------------------------------------------+
// 1.4.2  27/03/2011     |
//         "1-2-3".   ""/"" |
//          ""  "" .                   |
//+------------------------------------------------------------------+
// 1.4.3  29/03/2011             |
//                        |
//          .                             |
//+------------------------------------------------------------------+
// 1.4.4  31/03/2011        |
//        "" StopLoss.            |
//         TakeProfit.                                        |
//+------------------------------------------------------------------+
// 1.4.5  03/04/2011    .      |
//         ""  "" ()       |
//        :                                               |
//        1)  ;                                       |
//        2)     TakeProfit.                 |
//+------------------------------------------------------------------+
// 1.4.6  07/04/2011  ""  "" ()     |
//          ""               |
//         StopLoss.                                     |
//+------------------------------------------------------------------+
// 1.4.7  13/04/2011   ""     | 
//        StopLoss   .              |
//                    |
//        .                                               |
//+------------------------------------------------------------------+
// 1.4.8  18/04/2011  ""  "" ()     |
//           "" TakeProfit, |
//           TakeProfit  Impulse.     |
//                     |
//              .   |
//+------------------------------------------------------------------+
#property copyright " .."
#property indicator_chart_window
#property indicator_buffers 8
//---- buffers
double HighHF[], LowHF[], HighLF[], LowLF[],
       BuyOpen[], SellOpen[], BuyClose[], SellClose[];
//---- parameters
// Hight Frequency: 
#property indicator_color1 Red  //   
#property indicator_color2 Green //   
#property indicator_width1 1    //   
#property indicator_width2 1    //   
extern bool StrongLeftHF=false, //   
            StrongRightHF=false,//   
            RepeatHF=true,      //  / 
            ByCloseHF=false,    //    
            SignalsHF=false;    //  ,   
bool NotFirstStartHF, Ban1HF, Ban2HF;
extern int BarsBeforeHF=3,      //    
           BarsAfterHF=1,       //    
           ArrowHF=163;         //   /
// Low Frequency: 
#property indicator_color3 Yellow //   
#property indicator_color4 PaleTurquoise //   
#property indicator_width3 3    //   
#property indicator_width4 3    //   
extern bool StrongLeftLF=false, //   
            StrongRightLF=false,//   
            RepeatLF=true,      //  / 
            ByCloseLF=false,    //    
            SignalsLF=false;    //  ,   
bool NotFirstStartLF, Ban1LF, Ban2LF;
extern int BarsBeforeLF=10,     //    
           BarsAfterLF=2,       //    
           ArrowLF=163;         //   /
//  :
double MaxLots;                 //   
extern double BullImpulse=1,    //     
              BearImpulse=1,    //          
              Martingale=2, //       SL
              LotsLimit=4;  //    
extern bool Point2isFractalHF=true,  //  2 -  HF 
            Point2isExtremum=false,   //  2 -   
            Point3isInRange1_2=true, //  3 -    1-2
            PatternsOverlap=false,   //   
            LockIsAllowed=false,     //  
            BanContraTrendOpen=false,//    
            SetShortStopLoss=false,  // "" SL  
            BuyIsAllowed=true,       //  
            SellIsAllowed=true,      //  
            ShortBullStopLoss=false, // ""  
            ShortBearStopLoss=false, // ""  
            BullStopLossOverturn=true, //   SL  
            BearStopLossOverturn=true, //   SL  
            SetBearTakeProfit=true,  //   TP  Sell
            SetBullTakeProfit=true,  //   TP  Buy
            ShortBullTakeProfit=false, // ""   TP
            ShortBearTakeProfit=false, // ""   TP
            ClearAtFinish=false; //    
extern int OverturnsLimit=3, //    
           AnalyzedBars=600, //     
           OrderLevelStyle=STYLE_DASH, //   
           PositionLevelWidth=2; //   
extern color Bear123Color=Pink,  //   
             Bull123Color=PaleGreen; //   
//     :
extern int StopLossStyle=STYLE_DOT,   //   
           TakeProfitStyle=STYLE_DOT; //   
#property indicator_color5 Red   //    Sell
#property indicator_color6 Green //    Buy
#property indicator_width5 5     //    Sell
#property indicator_width6 5     //    Buy
extern int ArrowSell=242,        //    Sell
           ArrowBuy=241;         //    Buy
#property indicator_color7 Red   //    Sell
#property indicator_color8 Green //    Buy
#property indicator_width7 5     //    Sell
#property indicator_width8 5     //    Buy
extern int ArrowSellClose=251,   //    Sell
           ArrowBuyClose=251;    //    Buy
int Bull.Profit, Bull.Deals, Bear.Profit, Bear.Deals, Overturns, MaxOverturns;
string NameStop="Stop",
       NameTake="Take",
       NameOrder="Order",
       NamePattern="Pattern";
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, ArrowHF);
   SetIndexBuffer(0, HighHF);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, ArrowHF);
   SetIndexBuffer(1, LowHF);
   SetIndexEmptyValue(1, 0.0);
   SetIndexStyle(2, DRAW_ARROW);
   SetIndexArrow(2, ArrowLF);
   SetIndexBuffer(2, HighLF);
   SetIndexEmptyValue(2, 0.0);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexArrow(3, ArrowLF);
   SetIndexBuffer(3, LowLF);
   SetIndexEmptyValue(3, 0.0);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexArrow(4, ArrowSell);
   SetIndexBuffer(4, SellOpen);
   SetIndexEmptyValue(4, 0.0);
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexArrow(5, ArrowBuy);
   SetIndexBuffer(5, BuyOpen);
   SetIndexEmptyValue(5, 0.0);
   SetIndexStyle(6, DRAW_ARROW);
   SetIndexArrow(6, ArrowSellClose);
   SetIndexBuffer(6, SellClose);
   SetIndexEmptyValue(6, 0.0);
   SetIndexStyle(7, DRAW_ARROW);
   SetIndexArrow(7, ArrowBuyClose);
   SetIndexBuffer(7, BuyClose);
   SetIndexEmptyValue(7, 0.0);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("SFSM");
   if( SignalsHF )
     {
      SetIndexLabel(0, "Sell_HF");
      SetIndexLabel(1, "Buy_HF");
     }
   else
     {
      SetIndexLabel(0, "High_HF");
      SetIndexLabel(1, "Low_HF");
     }
   if( SignalsLF )
     {
      SetIndexLabel(2, "Sell_LF");
      SetIndexLabel(3, "Buy_LF");
     }
   else
     {
      SetIndexLabel(2, "High_LF");
      SetIndexLabel(3, "Low_LF");
     }
   SetIndexLabel(4, "Sell_Open");
   SetIndexLabel(5, "Buy_Open");
   SetIndexLabel(6, "Sell_Close");
   SetIndexLabel(7, "Buy_Close");
//      : 
   NotFirstStartHF=false;
   Ban1HF=false;
   Ban2HF=false;
   if( BarsBeforeHF<1 ) BarsBeforeHF=1;
   if( BarsAfterHF<1 ) BarsAfterHF=1;
   NotFirstStartLF=false;
   Ban1LF=false;
   Ban2LF=false;
   if( BarsBeforeLF<BarsBeforeHF ) BarsBeforeLF=BarsBeforeHF;
   if( BarsAfterLF<BarsAfterHF ) BarsAfterLF=BarsAfterHF;
   if( AnalyzedBars<1 || AnalyzedBars>Bars ) AnalyzedBars=Bars;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   if( ClearAtFinish ) ClearScreen(); //   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if( !NewBar() ) return(0);
   double R, C[];
   int dim, i, j, k, D, BarsBefore, BarsAfter;
   bool ByClose, StrongLeft, StrongRight, Repeat,
        Signals, NotFirstStart, Ban1, Ban2, NewParameters;
   Bull.Profit=0;
   Bull.Deals=0;
   Bear.Profit=0;
   Bear.Deals=0;
   MaxLots=0;
   datetime DeadLine=Time[AnalyzedBars-1];
   ArrayInitialize(BuyOpen,0.0);          //  
   ArrayInitialize(BuyClose,0.0);
   ArrayInitialize(SellOpen,0.0);
   ArrayInitialize(SellClose,0.0);
   while( k<2 )                                 //  HF  LF
     {
      if( k==0 )
        {
         StrongLeft=StrongLeftHF;
         StrongRight=StrongRightHF;
         Repeat=RepeatHF;
         NotFirstStart=NotFirstStartHF;
         Ban1=Ban1HF;
         Ban2=Ban2HF;
         BarsBefore=BarsBeforeHF;
         BarsAfter=BarsAfterHF;
         Signals=SignalsHF;
         ByClose=ByCloseHF;
        }
      else
        {
         StrongLeft=StrongLeftLF;
         StrongRight=StrongRightLF;
         Repeat=RepeatLF;
         NotFirstStart=NotFirstStartLF;
         Ban1=Ban1LF;
         Ban2=Ban2LF;
         BarsBefore=BarsBeforeLF;
         BarsAfter=BarsAfterLF;
         Signals=SignalsLF;
         ByClose=ByCloseLF;
        }
      dim=ArrayResize(C, BarsBefore+1+BarsAfter);
      if( NotFirstStart ) i=BarsAfter+1; else i=AnalyzedBars-BarsBefore-1;
//----  
      while( i > BarsAfter )
        {
         j=0;
         if( ByClose )
           {
            while ( j < dim ) { C[j]=Close[j+i-BarsAfter]; j++; }
            if( MathAbs(C[BarsAfter+1]-C[BarsAfter]) < Point
             && MathAbs(C[BarsAfter-1]-C[BarsAfter]) < Point )
              { i--; continue; }                //  
            if( C[BarsAfter+1] > C[BarsAfter] )
               if( C[BarsAfter] <= C[BarsAfter-1] )
                 { D=-1; R=C[BarsAfter]; }      //  
               else { i--; continue; }          //  
            else
               if( C[BarsAfter] >= C[BarsAfter-1] )
                 { D=1; R=C[BarsAfter]; }       //  
               else { i--; continue; }          //  
            j=1;
            while ( j < dim )
              {
               if( D > 0 )                      //  ?
               if( ( j < BarsAfter && C[j-1] > C[j] && StrongRight )
                || ( j < BarsAfter && C[j-1] > R && !StrongRight )
                || ( j > BarsAfter && C[j] >= C[j-1] && StrongLeft )
                || ( j > BarsAfter && C[j] >= R && !StrongLeft ) )
                 { D=0; break; }                //  
               if( D < 0 )                      //  ?
               if( ( j < BarsAfter && C[j-1] < C[j] && StrongRight )
                || ( j < BarsAfter && C[j-1] < R && !StrongRight )
                || ( j > BarsAfter && C[j] <= C[j-1] && StrongLeft )
                || ( j > BarsAfter && C[j] <= R && !StrongLeft ) )
                 { D=0; break; }                //  
               j++;
              }
            if( D == 0 ) { i--; continue; }     //  
            if( Signals )
              {
               j=i-BarsAfter-1;                 //  
               R=Open[j];                       //  
              }
            else j=i;                           //  
            //         :
            if( D>0 && !Ban1 )
              {
               if( k==0 ) HighHF[j]=R; else HighLF[j]=R;
               if( !Repeat ) { Ban1=true; Ban2=false; }
              }
            else if( D<0 && !Ban2 )
              {
               if( k==0 ) LowHF[j]=R; else LowLF[j]=R;
               if( !Repeat ) { Ban1=false; Ban2=true; }
              }
           }
         else
           {
            R=0;
            while ( j < dim ) { C[j]=High[j+i-BarsAfter]; j++; }
            if( C[BarsAfter+1] < C[BarsAfter] && C[BarsAfter] >= C[BarsAfter-1] )
              {
               R=C[BarsAfter];                  //  
               j=1;
               while ( j < dim )
                 {
                  if( ( j < BarsAfter && C[j-1] > C[j] && StrongRight )
                   || ( j < BarsAfter && C[j-1] > R && !StrongRight )
                   || ( j > BarsAfter && C[j] >= C[j-1] && StrongLeft )
                   || ( j > BarsAfter && C[j] >= R && !StrongLeft ) )
                    { R=0; break; }             //  
                  j++;
                 }
              }
            if( R >= Point )
              {
               if( Signals )
                 {
                  j=i-BarsAfter-1;              //  
                  R=Open[j];                    //  
                 }
               else j=i;                        //  
               if( !Ban1 )
                 {   //         
                  if( k==0 ) HighHF[j]=R; else HighLF[j]=R;
                  if( !Repeat ) { Ban1=true; Ban2=false; }
                 }
              }
            R=0;
            j=0;
            while ( j < dim ) { C[j]=Low[j+i-BarsAfter]; j++; }
            if( C[BarsAfter+1] > C[BarsAfter] && C[BarsAfter] <= C[BarsAfter-1] )
              {
               R=C[BarsAfter];                  //  
               j=1;
               while ( j < dim )
                 {
                  if( ( j < BarsAfter && C[j-1] < C[j] && StrongRight )
                   || ( j < BarsAfter && C[j-1] < R && !StrongRight )
                   || ( j > BarsAfter && C[j] <= C[j-1] && StrongLeft )
                   || ( j > BarsAfter && C[j] <= R && !StrongLeft ) )
                    { R=0; break; }             //  
                  j++;
                 }
              }
            if( R >= Point )
              {
               if( Signals )
                 {
                  j=i-BarsAfter-1;              //  
                  R=Open[j];                    //  
                 }
               else j=i;                        //  
               if( !Ban2 )
                 {   //         
                  if( k==0 ) LowHF[j]=R; else LowLF[j]=R;
                  if( !Repeat ) { Ban1=false; Ban2=true; }
                 }
              }
           }
         i--;
        }
      if( !NotFirstStart ) NotFirstStart=true;
      if( k==0 )
        {
         NotFirstStartHF=NotFirstStart;
         Ban1HF=Ban1;
         Ban2HF=Ban2;
        }
      else
        {
         NotFirstStartLF=NotFirstStart;
         Ban1LF=Ban1;
         Ban2LF=Ban2;
        }
      k++;
     }                                          //  
//----
   ClearScreen();                               //   
   FindPatterns();                              //    
   if( SetShortStopLoss )
     {
      if( Bull.Profit<0 && !ShortBullStopLoss )
        {
         ShortBullStopLoss=true;
         NewParameters=true;
         Print("ShortBullStopLoss (BullProfit="+Bull.Profit+")");
        }
      else Print("LongBullStopLoss (BullProfit="+Bull.Profit+")");
      if( Bear.Profit<0 && !ShortBearStopLoss )
        {
         ShortBearStopLoss=true;
         NewParameters=true;
         Print("ShortBearStopLoss (BearProfit="+Bear.Profit+")");
        }
      else Print("LongBearStopLoss (BearProfit="+Bear.Profit+")");
      if( NewParameters )
        {
         Bull.Profit=0;
         Bull.Deals=0;
         Bear.Profit=0;
         Bear.Deals=0;
         ArrayInitialize(BuyOpen,0.0);          //  
         ArrayInitialize(BuyClose,0.0);
         ArrayInitialize(SellOpen,0.0);
         ArrayInitialize(SellClose,0.0);
         ClearScreen();                         //   
         FindPatterns();                        //    
        }
     }
   if( BanContraTrendOpen )
     {
      if( Bull.Profit<0 && BuyIsAllowed )
        {
         BuyIsAllowed=false;
         NewParameters=true;
         Print("BuyIsNotAllowed (BullProfit="+Bull.Profit+")");
        }
      else Print("BuyIsAllowed (BullProfit="+Bull.Profit+")");
      if( Bear.Profit<0 && SellIsAllowed )
        {
         SellIsAllowed=false;
         NewParameters=true;
         Print("SellIsNotAllowed (BearProfit="+Bear.Profit+")");
        }
      else Print("SellIsAllowed (BearProfit="+Bear.Profit+")");
      if( NewParameters )
        {
         Bull.Profit=0;
         Bull.Deals=0;
         Bear.Profit=0;
         Bear.Deals=0;
         ArrayInitialize(BuyOpen,0.0);          //  
         ArrayInitialize(BuyClose,0.0);
         ArrayInitialize(SellOpen,0.0);
         ArrayInitialize(SellClose,0.0);
         ClearScreen();                         //   
         FindPatterns();                        //    
        }
     }
   int Total.Profit=Bear.Profit+Bull.Profit,
       Total.Deals=Bear.Deals+Bull.Deals,
       ProfitPerDeal,
       BarsPerDeal,
       ProfitPerBar;
       if( Total.Deals>0 )
         {
          ProfitPerDeal=Total.Profit/Total.Deals;
          BarsPerDeal=AnalyzedBars/Total.Deals;
         }
       ProfitPerBar=Total.Profit/AnalyzedBars;
   Comment("DeadLine: "+TimeToStr(DeadLine)+
           " BearPoints="+Bear.Profit+
           " BearDeals="+Bear.Deals+
           " BullPoints="+Bull.Profit+
           " BullDeals="+Bull.Deals+
           " TotalPoints="+ Total.Profit+
           " TotalDeals="+Total.Deals+
           " PointsPerDeal="+ProfitPerDeal+
           " TotalBars="+AnalyzedBars+
           " BarsPerDeal="+BarsPerDeal+
           " PointsPerBar="+ProfitPerBar+
           " MaxLots="+DoubleToStr(MaxLots,2)+
           " MaxOverturns="+MaxOverturns);
   WindowRedraw();                              //  
   Print("DeadLine: "+TimeToStr(DeadLine)+
         " BearPoints="+Bear.Profit+
         " BearDeals="+Bear.Deals+
         " BullPoints="+Bull.Profit+
         " BullDeals="+Bull.Deals+
         " TotalPoints="+ Total.Profit+
         " TotalDeals="+Total.Deals+
         " PointsPerDeal="+ProfitPerDeal+
         " TotalBars="+AnalyzedBars+
         " BarsPerDeal="+BarsPerDeal+
         " PointsPerBar="+ProfitPerBar+
         " MaxLots="+DoubleToStr(MaxLots,2)+
         " MaxOverturns="+MaxOverturns);
   return(0);
  }
//+------------------------------------------------------------------+
//|    (.)
//+------------------------------------------------------------------+
void ClearScreen()
  {
//----
   Comment("                                                       "+
           "                                                       "+
           "                                                       ");
   string Pref1=NamePattern,
          Pref2=NameOrder,
          Pref3=NameStop,
          Pref4=NameTake;
   for(int k=ObjectsTotal()-1; k>=0; k--)
     {
      string Obj_Name=ObjectName(k);
      string Head1=StringSubstr(Obj_Name,0,StringLen(Pref1));
      string Head2=StringSubstr(Obj_Name,0,StringLen(Pref2));
      string Head3=StringSubstr(Obj_Name,0,StringLen(Pref3));
      string Head4=StringSubstr(Obj_Name,0,StringLen(Pref4));
      if ( Head1==Pref1 || Head2==Pref2 || Head3==Pref3 || Head4==Pref4 )
         ObjectDelete(Obj_Name);
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//|   1-2-3
//+------------------------------------------------------------------+
void Paint.123(datetime Time0,datetime Time1,datetime Time2,datetime Close.Time,
               double Price1,double Price2,double Close.Price,double StopLoss,
               double TakeProfit,color Color,int Width,int Number,string Order,double Lots=1)
  {
//----
   string Name="Pattern #"+Number,
          Text;
   color PatternColor;
   bool Result;
   if( Time1>0 )
     {
      Result=ObjectCreate(Name,OBJ_RECTANGLE,0,Time1,Price1,Time0,Price2);
      if( Price2>Price1 )
        {
         Text="   Bull-123#";
         PatternColor=Bull123Color;
        }
      else
        {
         Text="   Bear-123#";
         PatternColor=Bear123Color;
        }
      Text=Text+Number;
      Result=Result && ObjectSetText(Name,Text);
      Result=Result && ObjectSet(Name,OBJPROP_COLOR,PatternColor);
      Result=Result && ObjectSet(Name,OBJPROP_BACK,true);
     }
   
   if( Close.Time>Time0 )
     {
      Name="Order #"+Number;
      Result=ObjectCreate(Name,OBJ_TREND,0,Time0,Price2,Close.Time,Close.Price);
      Text=Order+Number;
      if( MathAbs(Lots-1)>Point*0.5 ) Text=Text+"("+DoubleToStr(Lots,2)+")";
      Result=Result && ObjectSetText(Name,Text);
      Result=Result && ObjectSet(Name,OBJPROP_RAY,false);
      Result=Result && ObjectSet(Name,OBJPROP_COLOR,Color);
      Result=Result && ObjectSet(Name,OBJPROP_WIDTH,Width);
      Result=Result && ObjectSet(Name,OBJPROP_BACK,true);
      if( Width<2 ) Result=Result && ObjectSet(Name,OBJPROP_STYLE,OrderLevelStyle);
     }
   else Close.Time=Time[0];
   if( Close.Time==Time0 ) return;
   
   if( StopLoss>Point*0.5 )
     {
      Name="Stop #"+Number;
      Result=ObjectCreate(Name,OBJ_TREND,0,Time0,StopLoss,Close.Time,StopLoss);
      Text="         SL#"+Number;
      Result=Result && ObjectSetText(Name,Text);
      Result=Result && ObjectSet(Name,OBJPROP_RAY,false);
      Result=Result && ObjectSet(Name,OBJPROP_COLOR,Color);
      Result=Result && ObjectSet(Name,OBJPROP_STYLE,StopLossStyle);
      Result=Result && ObjectSet(Name,OBJPROP_BACK,true);
     }
   
   if( TakeProfit>Point*0.5 )
     {
      Name="Take #"+Number;
      Result=ObjectCreate(Name,OBJ_TREND,0,Time0,TakeProfit,Close.Time,TakeProfit);
      Text="         TP#"+Number;
      Result=Result && ObjectSetText(Name,Text);
      Result=Result && ObjectSet(Name,OBJPROP_RAY,false);
      Result=Result && ObjectSet(Name,OBJPROP_COLOR,Color);
      Result=Result && ObjectSet(Name,OBJPROP_STYLE,TakeProfitStyle);
      Result=Result && ObjectSet(Name,OBJPROP_BACK,true);
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//|    1-2-3
//+------------------------------------------------------------------+
void Bear.123(int Bar1, int Bar2,int& Number)
  {
//----
   string Order="     Sell#";
   double Price1=HighLF[Bar1],                  //   () 
          Price2=LowHF[Bar2],                   //   () 
          Price3,
          Close.Price,
          Lots=1,
          StopLoss,
          TakeProfit;
   datetime Time1=Time[Bar1],                   //   () 
            Time2=Time[Bar2],                   //   () 
            Time0,                              //   
            Close.Time;                         //   
   int Bar0=Bar2-1,                             //   
       Close.Bar=-1,                            //   
       Width;                                   //   
   color  Color=indicator_color1;               //  
   while( Bar0>=0 )
     {
      if( Price3<High[Bar0] ) Price3=High[Bar0];
      if( Low[Bar0]<Price2 )
        {                                       //  
         if( SellIsAllowed ) SellOpen[Bar0]=Price2;
         break;
        }
      if( Point3isInRange1_2 && High[Bar0]>Price1 )
        {                                       //  
         Number--;
         return;
        }
      Bar0--;
     }
   if( Bar0<0 ) Bar0=0;
   Time0=Time[Bar0];
   if( SetBearTakeProfit )
     {
      TakeProfit=-BearImpulse*(Price1-Price2);
      if( ShortBearTakeProfit ) TakeProfit+=Price3; else TakeProfit+=Price2;
     }
   if( ShortBearStopLoss ) StopLoss=Price3; else StopLoss=Price1;
   Close.Bar=Bar0-1;
   while( Close.Bar>=0 )
     {
      if( !SellIsAllowed )
        {
         TakeProfit=0;
         StopLoss=0;
         break;
        }
      if( !LockIsAllowed && BuyOpen[Close.Bar]>Point*0.5 )
        {
         Close.Price=BuyOpen[Close.Bar];
         TakeProfit=0;
         StopLoss=0;
         break;
        }
      if( High[Close.Bar]-StopLoss>-Point*0.5 )
        {
         Close.Price=StopLoss;
         TakeProfit=0;
         if( BearStopLossOverturn && Overturns<OverturnsLimit )
           {
            Overturns+=1;
            BearOverturn(Number,Close.Bar,Close.Price,Price2,StopLoss+(StopLoss-Price2),Lots);
           }
         Overturns=0;
         break;
        }
      if( TakeProfit-Low[Close.Bar]>-Point*0.5 )
        {
         Close.Price=TakeProfit;
         StopLoss=0;
         break;
        }
      Close.Bar--;
     }
   if( SellIsAllowed && Close.Bar>=0 )
     {
      Close.Time=Time[Close.Bar];
      SellClose[Close.Bar]=Close.Price;
      Width=PositionLevelWidth;
      Bear.Profit+=(Price2-Close.Price)/Point;
      Bear.Deals+=1;
     }
   Paint.123(Time0,Time1,Time2,Close.Time,Price1,Price2,Close.Price,
             StopLoss,TakeProfit,Color,Width,Number,Order);
//----
   return;
  }
//+------------------------------------------------------------------+
//|       StopLoss
//+------------------------------------------------------------------+
void BearOverturn(int& Number,int Bar0,double Price2,double StopLoss,
                  double TakeProfit,double& Lots)
  {
//----
   string Order="     Buy#";
   int Close.Bar=-1,                            //   
       Width;                                   //   
   color  Color=indicator_color2;               //  ;
   datetime Time1,                              //   () 
            Time2,                              //   () 
            Time0,                              //   
            Close.Time;                         //   
   double Price1,                               //   () 
          Close.Price,                          //   
          OldLots;
   if( Bar0<0 ) Bar0=0;
   BuyOpen[Bar0]=Price2;
   Time0=Time[Bar0];
   Close.Bar=Bar0-1;
   while( Close.Bar>=0 )
     {
      if( StopLoss-Low[Close.Bar]>-Point*0.5 )
        {
         Close.Price=StopLoss;
         TakeProfit=0;
         if( Overturns<OverturnsLimit )
           {
            Overturns+=1;
            if( MaxOverturns<Overturns ) MaxOverturns=Overturns;
            OldLots=Lots;
            if( Lots<LotsLimit ) Lots*=Martingale;
            BullOverturn(Number,Close.Bar,Close.Price,Price2,StopLoss-(Price2-StopLoss),Lots);
            Lots=OldLots;
           }
         break;
        }
      if( High[Close.Bar]-TakeProfit>-Point*0.5 )
        {
         Close.Price=TakeProfit;
         StopLoss=0;
         break;
        }
      Close.Bar--;
     }
   if( Close.Bar>=0 )
     {
      Close.Time=Time[Close.Bar];
      BuyClose[Close.Bar]=Close.Price;
      Width=PositionLevelWidth;
      Bull.Profit+=Lots*(Close.Price-Price2)/Point;
      Bull.Deals+=1;
      if( Lots>MaxLots ) MaxLots=Lots;
     }
   Paint.123(Time0,Time1,Time2,Close.Time,Price1,Price2,Close.Price,
             StopLoss,TakeProfit,Color,Width,Number,Order,Lots);
   Number++;
//----
   return;
  }
//+------------------------------------------------------------------+
//|       StopLoss
//+------------------------------------------------------------------+
void BullOverturn(int& Number,int Bar0,double Price2,double StopLoss,
                  double TakeProfit,double& Lots)
  {
//----
   string Order="     Sell#";
   int Close.Bar=-1,                            //   
       Width;                                   //   
   color  Color=indicator_color1;               //  ;
   datetime Time1,                              //   () 
            Time2,                              //   () 
            Time0,                              //   
            Close.Time;                         //   
   double Price1,                               //   () 
          Close.Price,                          //   
          OldLots;
   if( Bar0<0 ) Bar0=0;
   SellOpen[Bar0]=Price2;
   Time0=Time[Bar0];
   Close.Bar=Bar0-1;
   while( Close.Bar>=0 )
     {
      if( High[Close.Bar]-StopLoss>-Point*0.5 )
        {
         Close.Price=StopLoss;
         if( Overturns<OverturnsLimit )
           {
            Overturns+=1;
            if( MaxOverturns<Overturns ) MaxOverturns=Overturns;
            OldLots=Lots;
            if( Lots<LotsLimit ) Lots*=Martingale;
            BearOverturn(Number,Close.Bar,Close.Price,Price2,StopLoss+(StopLoss-Price2),Lots);
            Lots=OldLots;
           }
         TakeProfit=0;
         break;
        }
      if( TakeProfit-Low[Close.Bar]>-Point*0.5 )
        {
         Close.Price=TakeProfit;
         StopLoss=0;
         break;
        }
      Close.Bar--;
     }
   if( Close.Bar>=0 )
     {
      Close.Time=Time[Close.Bar];
      SellClose[Close.Bar]=Close.Price;
      Width=PositionLevelWidth;
      Bear.Profit+=Lots*(Price2-Close.Price)/Point;
      Bear.Deals+=1;
      if( Lots>MaxLots ) MaxLots=Lots;
     }
   Paint.123(Time0,Time1,Time2,Close.Time,Price1,Price2,Close.Price,
             StopLoss,TakeProfit,Color,Width,Number,Order,Lots);
   Number++;
//----
   return;
  }
//+------------------------------------------------------------------+
//|    1-2-3
//+------------------------------------------------------------------+
void Bull.123(int Bar1, int Bar2,int& Number)
  {
//----
   string Order="     Buy#";
   double Price1=LowLF[Bar1],                   //   () 
          Price2=HighHF[Bar2],                  //   () 
          Price3=1000000000,
          Close.Price,                          //   
          Lots=1,
          StopLoss,
          TakeProfit;
   datetime Time1=Time[Bar1],                   //   () 
            Time2=Time[Bar2],                   //   () 
            Time0,                              //   
            Close.Time;                         //   
   int Bar0=Bar2-1,                             //   
       Close.Bar=-1,                            //   
       Width;                                   //   
   color  Color=indicator_color2;               //  
   while( Bar0>=0 )
     {
      if( Price3>Low[Bar0] ) Price3=Low[Bar0];
      if( High[Bar0]>Price2 )
        {                                       //  
         if( BuyIsAllowed ) BuyOpen[Bar0]=Price2;
         break;
        }
      if( Point3isInRange1_2 && Low[Bar0]<Price1 )
        {                                       //  
         Number--;
         return;
        }
      Bar0--;
     }
   if( Bar0<0 ) Bar0=0;
   Time0=Time[Bar0];
   if( SetBullTakeProfit )
     {
      TakeProfit=BullImpulse*(Price2-Price1);
      if( ShortBullTakeProfit ) TakeProfit+=Price3; else TakeProfit+=Price2;
     }
   if( ShortBullStopLoss ) StopLoss=Price3; else StopLoss=Price1;
   Close.Bar=Bar0-1;
   while( Close.Bar>=0 )
     {
      if( !BuyIsAllowed )
        {
         TakeProfit=0;
         StopLoss=0;
         break;
        }
      if( !LockIsAllowed && SellOpen[Close.Bar]>Point*0.5 )
        {
         Close.Price=SellOpen[Close.Bar];
         TakeProfit=0;
         StopLoss=0;
         break;
        }
      if( StopLoss-Low[Close.Bar]>-Point*0.5 )
        {
         Close.Price=StopLoss;
         if( BullStopLossOverturn && Overturns<OverturnsLimit )
           {
            Overturns+=1;
            BullOverturn(Number,Close.Bar,Close.Price,Price2,StopLoss-(Price2-StopLoss),Lots);
           }
         Overturns=0;
         TakeProfit=0;
         break;
        }
      if( SetBullTakeProfit && High[Close.Bar]-TakeProfit>-Point*0.5 )
        {
         Close.Price=TakeProfit;
         StopLoss=0;
         break;
        }
      Close.Bar--;
     }
   if( BuyIsAllowed && Close.Bar>=0 )
     {
      Close.Time=Time[Close.Bar];
      BuyClose[Close.Bar]=Close.Price;
      Width=PositionLevelWidth;
      Bull.Profit+=(Close.Price-Price2)/Point;
      Bull.Deals+=1;
     }
   Paint.123(Time0,Time1,Time2,Close.Time,Price1,Price2,Close.Price,
             StopLoss,TakeProfit,Color,Width,Number,Order);
//----
   return;
  }
//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void FindPatterns()
  {
//----
   int Number,                                  //  
       Bar1,                                    //    
       Bar2=BarsAfterHF,                        //    
       Out=AnalyzedBars-BarsBeforeHF;           //    
   string Name;
   bool BullBan, BearBan;
   datetime Time1, Time2;
   while( Bar2<Out )
     {
      if( Point2isFractalHF &&                  // LF  
        ( HighLF[Bar2]>Point*0.5 || LowLF[Bar2]>Point*0.5 ) )
        { Bar2++; continue; }                   // LF 
      if( HighHF[Bar2]>Point*0.5 || HighLF[Bar2]>Point*0.5 )
        {                                       // High 
         Bar1=Bar2;
         while( Bar1<Out )
           {
            if( LowLF[Bar1]>Point*0.5 )
              {                                 //  
               Number++;
               Bull.123(Bar1,Bar2,Number);
               break;
              }
            if( Point2isExtremum &&             //  2 -   
                High[Bar1]>HighHF[Bar2] ) break;
            Bar1++;
            if( !PatternsOverlap &&             //   
              ( HighLF[Bar1]>Point*0.5 || HighHF[Bar1]>Point*0.5 ) ) break;
           }
        }
      else if( LowHF[Bar2]>Point*0.5 || LowLF[Bar2]>Point*0.5 )
        {                                       // Low 
         Bar1=Bar2;
         while( Bar1<Out )
           {
            if( HighLF[Bar1]>Point*0.5 )
              {                                 //  
               Number++;
               Bear.123(Bar1,Bar2,Number);
               break;
              }
            if( Point2isExtremum &&             //  2 -   
                Low[Bar1]<LowHF[Bar2] ) break;
            Bar1++;
            if( !PatternsOverlap &&             //   
              ( LowLF[Bar1]>Point*0.5 || LowHF[Bar1]>Point*0.5 ) ) break;
           }
        }
      Bar2++;
     }
   //          BullPositionsRefill=false, //    
   //          BearPositionsRefill=false, //    
   //          BullStopLossOverturn=true, //   SL  
   //          BearStopLossOverturn=true, //   SL  
   while( Number>0 )
     {
      if( ObjectFind(NameTake)==0 ) Name=NameTake; else Name=NameStop;
      Time1=ObjectGet(Name,OBJPROP_TIME1);
      Time2=ObjectGet(Name,OBJPROP_TIME2);
      Bar1=iBarShift(NULL,0,Time1);             //   
      Bar2=iBarShift(NULL,0,Time2);             //   
      if( Name==NameStop )
        {                                       //   StopLoss
         
        }
      Number--;
     }
//----
   return;
  }
//+------------------------------------------------------------------+
//|    (.)
//+------------------------------------------------------------------+
bool NewBar() 
  {
//----
   static datetime NewTime;               //   
   bool NewBar=false;                     //   
   if( NewTime!=Time[0] )
     {
      NewTime=Time[0];                    //   
      NewBar=true;                        //   
     }
//----
   return(NewBar);
  }
//+------------------------------------------------------------------+